<?php
    namespace App\Controllers;
    use Psr\Http\Message\ServerRequestInterface as Request;
    use Psr\Http\Message\ResponseInterface as Response;
    use App\Models\Menu;
    use App\Helpers\SendEmail;

    class MenuController
    {
        public function createOrUpdateMenu(Request $request, Response $response, $args)
        {
            $inputData = json_decode(file_get_contents('php://input'), true);
            $errorMessage = "";
            $successMessage = "";
            $params = [
                'storeId' => $inputData['storeId'] ?? '',
            ];

            # required fields error
            $errors = [];
            foreach ($params as $key => $value) {
                if (empty($value)) {
                    $errors[] = ucfirst($key) . ' is required';
                }
            }

            if(isset($inputData['flash'])) {
                $flash = 1;
            } else {
                $flash = 0;
            }
 
            if (empty($errors)) {
                $menu = new Menu();
                $getMenu = $menu->getMenu($params['storeId'], $flash);
                $successMessage = $getMenu;
            } else {
                $errorMessage = implode('. ', $errors);
            }


            # final error / success message
            if($errorMessage == "") {
                $urban = new UrbanController($params['storeId']);
                $ManagingCatalogueApi = $urban->ManagingCatalogueApi($successMessage, $flash);
                $ManagingCatalogueApi = json_decode($ManagingCatalogueApi);
                if($ManagingCatalogueApi->status == "success") {
                    $responseData = [
                        "status" => true, 
                        "message" => $ManagingCatalogueApi,
                        "response_code" => 200,
                    ];
                } else {
                    $responseData = [
                        "status" => false, 
                        "message" => $ManagingCatalogueApi->message,
                        "response_code" => 4020,
                    ];
                }
            } else {
                $responseData = [
                    "status" => false, 
                    "message" => $errorMessage,
                    "response_code" => 400,
                ];
            }
            $response->getBody()->write(json_encode($responseData));
            return $response;   
        } 
    }
?>