<?php
    namespace App\Controllers;
    use Psr\Http\Message\ServerRequestInterface as Request;
    use Psr\Http\Message\ResponseInterface as Response;
    use App\Models\OrderList;
    use App\Models\Urban;

    class OrderListController
    {
        public function getOrderList(Request $request, Response $response, $args)
        {
            $inputData = json_decode(file_get_contents('php://input'), true);
            $errorMessage = "";
            $successMessage = [];
            $params = [
                'domain' => $inputData['domain'] ?? '',
            ];
            
            # required fields error
            $errors = [];
            foreach ($params as $key => $value) {
                if (empty($value)) {
                    $errors[] = ucfirst($key) . ' is required';
                }
            }

            if (empty($errors)) {
                $urban = new Urban();
                $urbanStatus = $urban->getUrbanCredentials($params['domain']);
                if($urbanStatus != false) { 
                    $orderList = new OrderList();
                    // $orderData = $orderList->getOrderData($params['domain']);
                    $urbanPiperOrderData = $orderList->getUrbanPiperOrderData($params['domain']);
                    // $successMessage = $orderData;
                    $successMessage = $urbanPiperOrderData;
                    // $customSort = function ($a, $b) {
                    //     $paramToSortBy = 'placedTime';
                    //     if ($a[$paramToSortBy] == $b[$paramToSortBy]) {
                    //         return 0;
                    //     }
                    //     return ($a[$paramToSortBy] < $b[$paramToSortBy]) ? 1 : -1;
                    // };
                    // $successMessage = array_merge_recursive($orderData, $urbanPiperOrderData);
                    // usort($successMessage, $customSort);
                } else {
                    $errorMessage = "Urban piper disabled";
                }
            } else {
                $errorMessage = implode('. ', $errors);
            }

            # final error / success message
            if($errorMessage == "") { 
                $responseData = [
                    "status" => true, 
                    "message" => $successMessage,
                    "response_code" => 200,
                ];
            } else {
                $responseData = [
                    "status" => false, 
                    "message" => $errorMessage,
                    "response_code" => 400,
                ];
            }
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        public function getNewOrderCount(Request $request, Response $response, $args)
        {
            $inputData = json_decode(file_get_contents('php://input'), true);
            $errorMessage = "";
            $successMessage = [];
            $params = [
                'domain' => $inputData['domain'] ?? '',
            ];
            
            # required fields error
            $errors = [];
            foreach ($params as $key => $value) {
                if (empty($value)) {
                    $errors[] = ucfirst($key) . ' is required';
                }
            }

            if (empty($errors)) {
                $urban = new Urban();
                $urbanStatus = $urban->getUrbanCredentials($params['domain']);
                if($urbanStatus != false) { 
                    $orderList = new OrderList();
                    $orderData = $orderList->getNewOrderCount($params['domain']);
                    $successMessage = $orderData;
                } else {
                    $errorMessage = "Urban piper disabled";
                }
            } else {
                $errorMessage = implode('. ', $errors);
            }

            # final error / success message
            if($errorMessage == "") { 
                $responseData = [
                    "status" => true, 
                    "message" => $successMessage,
                    "response_code" => 200,
                ];
            } else {
                $responseData = [
                    "status" => false, 
                    "message" => $errorMessage,
                    "response_code" => 400,
                ];
            }
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        public function getSeparateOrderDetail(Request $request, Response $response, $args)
        {
            $inputData = json_decode(file_get_contents('php://input'), true);
            $errorMessage = "";
            $successMessage = [];
            $params = [
                'domain' => $inputData['domain'] ?? '',
                'orderId' => $inputData['orderId'] ?? '',
                'platformType' => $inputData['platformType'] ?? '',
            ];
            
            # required fields error
            $errors = [];
            foreach ($params as $key => $value) {
                if (empty($value)) {
                    $errors[] = ucfirst($key) . ' is required';
                }
            }

            if (empty($errors)) {
                $orderList = new OrderList();
                if($params['platformType'] == 1) {
                    $orderData = $orderList->getFusionOrderWithId($params['domain'], $params['orderId']);
                    $successMessage = $orderData;
                } else {
                    $orderData = $orderList->getUrbanOrderWithId($params['domain'], $params['orderId']);
                    $successMessage = $orderData;
                }
            } else {
                $errorMessage = implode('. ', $errors);
            }

            # final error / success message
            if($errorMessage == "") { 
                $responseData = [
                    "status" => true, 
                    "message" => $successMessage,
                    "response_code" => 200,
                ];
            } else {
                $responseData = [
                    "status" => false, 
                    "message" => $errorMessage,
                    "response_code" => 400,
                ];
            }
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        public function updateFusionOrderStatus(Request $request, Response $response, $args)
        {
            $inputData = json_decode(file_get_contents('php://input'), true);
            $errorMessage = "";
            $successMessage = "";
            $params = [
                'domain' => $inputData['domain'] ?? '',
                'orderId' => $inputData['orderId'] ?? '',
                'status' => $inputData['status'] ?? '',
            ];
            
            # required fields error
            $errors = [];
            foreach ($params as $key => $value) {
                if (empty($value)) {
                    $errors[] = ucfirst($key) . ' is required';
                }
            }

            if ($errorMessage == "") {
                $orderList = new OrderList();
                if($params['status'] == 4) {
                    if(empty($inputData['cancelReason'])) {
                        $errorMessage = "Cancel reason is missing";
                    } else {
                        $params['reason'] = $inputData['cancelReason'];
                        $params['command'] = $inputData['cancelCommand'];
                        $updateOrderStatus = $orderList->updateCancelOrderStatus($params['domain'], $params['orderId'], $params['status'], $params['reason'], $params['command']);
                        $successMessage = $updateOrderStatus;
                    }
                } else {
                    if($params['status'] == 1) {
                        if($inputData['cooking'] != 0) {
                            $getOrderDetail = $orderList->getOrderDetail($params['domain'], $params['orderId']);
                            $getCookingTime = $orderList->getCookingTime($params['domain']);
                            if($getOrderDetail['otype'] == 0) {
                                $cookingTime = $getCookingTime['delivery'];
                            } else {
                                $cookingTime = $getCookingTime['collection'];
                            }
                            $late = $inputData['cooking'] - $cookingTime;
                            $updateOrderStatus = $orderList->updateLateOrder($params['domain'], $params['orderId'], $late);
                        }
                    }
                    $updateOrderStatus = $orderList->updateOrderStatus($params['domain'], $params['orderId'], $params['status']);  
                    $successMessage = $updateOrderStatus;
                }
            } else {
                $errorMessage = implode('. ', $errors);
            }

            # final error / success message
            if($errorMessage == "") { 
                $responseData = [
                    "status" => true, 
                    "message" => "Updated Successfully",
                    "response_code" => 200,
                ];
            } else {
                $responseData = [
                    "status" => false, 
                    "message" => $errorMessage,
                    "response_code" => 400,
                ];
            }
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        public function assignFusionOrderDriver(Request $request, Response $response, $args)
        {
            $inputData = json_decode(file_get_contents('php://input'), true);
            $errorMessage = "";
            $successMessage = "";
            $params = [
                'domain' => $inputData['domain'] ?? '',
                'orderId' => $inputData['orderId'] ?? '',
                'driverId' => $inputData['driverId'] ?? '',
            ];
            
            # required fields error
            $errors = [];
            foreach ($params as $key => $value) {
                if (empty($value)) {
                    $errors[] = ucfirst($key) . ' is required';
                }
            }

            if ($errorMessage == "") {
                $orderList = new OrderList();
                $getOrderDriver = $orderList->getOrderDriver($params['domain'], $params['orderId']);
                if($getOrderDriver != false) {
                    $driverDetail = $orderList->getDriverWithId($params['domain'], $params['driverId']);
                    $orderList->updateOrderDriver($params['domain'], $driverDetail, $params['orderId']);                    
                } else {
                    $driverDetail = $orderList->getDriverWithId($params['domain'], $params['driverId']);
                    $orderList->createOrderDriver($params['domain'], $driverDetail, $params['orderId']);
                }
                $successMessage = $updateOrderStatus;
                
            } else {
                $errorMessage = implode('. ', $errors);
            }

            # final error / success message
            if($errorMessage == "") { 
                $responseData = [
                    "status" => true, 
                    "message" => "Updated Successfully",
                    "response_code" => 200,
                ];
            } else {
                $responseData = [
                    "status" => false, 
                    "message" => $errorMessage,
                    "response_code" => 400,
                ];
            }
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        public function hideOrderStatus(Request $request, Response $response, $args)
        {
            $inputData = json_decode(file_get_contents('php://input'), true);
            $errorMessage = "";
            $successMessage = "";
            $params = [
                'client' => $inputData['client'] ?? '',
                'orderId' => $inputData['orderId'] ?? '',
                'platform' => $inputData['platform'] ?? '',
            ];
            
            # required fields error
            $errors = [];
            foreach ($params as $key => $value) {
                if (empty($value)) {
                    $errors[] = ucfirst($key) . ' is required';
                }
            }

            if ($errorMessage == "") {
                $orderList = new OrderList();
                if($params['platform'] == 1) {
                    $updateOrderStatus = $orderList->updateHideFusionOrderStatus($params['client'], $params['orderId']);
                    $successMessage = $updateOrderStatus;
                } else {
                    $updateOrderStatus = $orderList->updateHideUrbanOrderStatus($params['client'], $params['orderId']);  
                    $successMessage = $updateOrderStatus;
                }
            } else {
                $errorMessage = implode('. ', $errors);
            }

            # final error / success message
            if($errorMessage == "") { 
                $responseData = [
                    "status" => true, 
                    "message" => "Updated Successfully",
                    "response_code" => 200,
                ];
            } else {
                $responseData = [
                    "status" => false, 
                    "message" => $errorMessage,
                    "response_code" => 400,
                ];
            }
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }


    
    }
?>