<?php
    namespace App\Controllers;
    use Psr\Http\Message\ServerRequestInterface as Request;
    use Psr\Http\Message\ResponseInterface as Response;
    use App\Models\Urban;
    require '../config/env.php';

    class SetupWebhookController
    {
        public function createBulkWebhooks(Request $request, Response $response, $args)
        {
            $inputData = json_decode(file_get_contents('php://input'), true);
            $errorMessage = "";
            $successMessage = [];
            $finalResponse = [];
            $params = [
                'storeId' => $inputData['storeId'] ?? '',
            ];

            # required fields error
            $errors = [];
            foreach ($params as $key => $value) {
                if (empty($value)) {
                    $errors[] = ucfirst($key) . ' is required';
                }
            }

            if(!empty($errors)) {
                $errorMessage = implode('. ', $errors);
            }

            # final error / success message
            if($errorMessage == "") {
                $urbanController = new UrbanController($params['storeId']);
            
                if($_SERVER['SERVER_NAME'] == $_ENV['LOCAL_SERVER_NAME'] || $_SERVER['SERVER_NAME'] == $_ENV['DEV_SERVER_NAME']) {
                    $url = $_ENV['TEST_URL'];
                } else {
                    $url = $_ENV['LIVE_URL'];
                }
                foreach($_ENV['EVENT_URL'] as $key => $event) {
                    $apiData['active'] =  true;
                    $apiData['event_type'] =  $key;
                    $apiData['retrial_interval_units'] =  "seconds";
                    $apiData['url'] = $url."/".$event;
                    $apiData['headers']['content-type'] =  "application/json";
                    $apiData['headers']['x_api_token'] =  "4trgfdsfd243tg54342rewfcef";
                    $createWebhook = $urbanController->createWebhook($apiData);
                    $createWebhook = json_decode($createWebhook);
                    $successMessage[$key] = $createWebhook;
                    $finalResponse[$key] = $apiData;
                }

                $successData = [];

                # get all webhook
                $allWebhook = [];
                $getWebhook = json_decode($urbanController->getWebhook());
                do {
                    foreach ($getWebhook->webhooks as $webhook) {
                        $allWebhook[] = $webhook;
                    }
                    
                    $nextValue = $getWebhook->meta->next;
                    if ($nextValue !== null) {
                        $getWebhook = json_decode($urbanController->getWebhook($nextValue));
                    }
                } while ($nextValue !== null);

                foreach($successMessage as $key => $data) {
                    $message = [
                        $key => $data->message
                    ];
                    if($data->status == "error") {
                        foreach ($allWebhook as $webhook) {
                            if ($webhook->active !== false && $webhook->event_type === $key) {
                                $finalResponse[$key]['webhook_id'] = $webhook->webhook_id;
                                array_push($successData, $message);
                            }
                        } 
                    } else {
                        $finalResponse[$key]['webhook_id'] = $data->webhook_id;
                        array_push($successData, $message);
                    }
                } 
                
                if(!empty($successData)) {
                    $urban = new Urban();
                    $updateWebhookDetails = $urban->updateWebhookDetails($finalResponse, $params['storeId']);

                    $responseData = [
                        "status" => true, 
                        "message" => $successMessage,
                        "response_code" => 200,
                    ];
                } else {
                    $responseData = [
                        "status" => false, 
                        "message" => $successMessage,
                        "response_code" => 400,
                    ];
                }
            } else {
                $responseData = [
                    "status" => false, 
                    "message" => $errorMessage,
                    "response_code" => 400,
                ];
            }
            $response->getBody()->write(json_encode($responseData));
            return $response;   
        } 
    }
?>