<?php
namespace App\Helpers;
use PHPMailer\PHPMailer\PHPMailer;
require '../config/env.php';

class SendEmail
{
    function sendMail($to, $cc, $sub, $html, $reply="",$replyName="", $from="", $fromName="")
    {
        if($from === "") {
            $from = $_ENV['MAIL_FROM'];
        }
        if($fromName === "") {
            $fromName = $_ENV['MAIL_FROM_NAME'];
        }
        $host = $_ENV['MAIL_HOST'];
        $username = $_ENV['MAIL_USERNAME'];
        $password = $_ENV['MAIL_PASSWORD'];
        $smtp = $_ENV['MAIL_SMTP'];

        if($reply == "") {
            $reply = $from;
        }
        if($replyName == "") {
            $replyName = "";
        }

        $mailer = new PHPMailer();
        $mailer->isSMTP();
        $mailer->SMTPDebug = false;
        $mailer->SMTPAutoTLS = true;
        $mailer->SMTPAuth   = true;
        $mailer->isHTML(true);
        $mailer->Host = $host;
        $mailer->Username = $username;
        $mailer->Password = $password;
        $mailer->SMTPSecure = $smtp;
        $mailer->Port = 465;
        $mailer->setFrom($from,$fromName);
        $mailer->addReplyTo($reply,$replyName);
        $mailer->addAddress($to);
        if(count($cc) > 0) {
            foreach($cc as $mail) {
                $mailer->addCC($mail); 
            }
        }
        $mailer->Subject = $sub;
        $mailer->Body = $html;
        if (!$mailer->send()) {
            return $mailer;
        } else {
            return true;
        }
    }
}