<?php
namespace App\Models;
require '../config/env.php';

class Menu extends DB
{
    public function getMenu($clientId, $flash)
    {
        $client = new Client($clientId);
        $visible = 0;
        $getCategory = $client->queryAll("CALL getCategoryWithoutStatus($visible)");
        $getSubcategory = $client->queryAll("CALL getSubcategoryWithoutStatus($visible)");
        $getItems = $client->queryAll("CALL getItemsWithoutStatus($visible)");
        $client->connectionClose();

        $finalMenuResponse = [];
        $finalMenuResponse['flush_categories'] = $flash == 1 ? true : false; # master level request
        $activeCategory = [];
        foreach ($getCategory as $key => $category) {
            if ($category->status == "1") {
                array_push($activeCategory, $category->id);
                $finalMenuResponse['categories'][$key] = [
                    'ref_id' => "$category->id",
                    'name' => str_replace(["<br>", "Â"], "", $category->name),
                    'description' => "", # new filed
                    'sort_order' => $category->order,
                    'active' => $category->status == "1" ? true : false,
                    // 'img_url' => "", # new filed
                    // 'parent_ref_id' => "", # new filed
                    'translations' => [], # new filed
                ];
            }
        }

        foreach ($getSubcategory as $subcategory) {
            if ($subcategory->status == "1") {
                array_push($activeCategory, "S-" . $subcategory->id);
                $subcategoryResponse['ref_id'] = "S-" . $subcategory->id;
                $subcategoryResponse['name'] = str_replace(["<br>", "Â"], "", $subcategory->name);
                $subcategoryResponse['description'] = str_replace(["<br>", "Â"], "", $subcategory->description);
                $subcategoryResponse['sort_order'] =  $subcategory->order;
                $subcategoryResponse['active'] =  $subcategory->status == "1" ? true : false;
                // $subcategoryResponse['img_url'] =  ""; # new filed
                $subcategoryResponse['parent_ref_id'] =  "$subcategory->catagery_id";
                $subcategoryResponse['translations'] =  []; # new filed
                array_push($finalMenuResponse['categories'], $subcategoryResponse);
            }
        }

        $finalMenuResponse['flush_items'] = $flash == 1 ? true : false; # master and local level request
        $finalMenuResponse['items'] = [];
        $finalMenuResponse['flush_option_groups'] = $flash == 1 ? true : false; # master level request
        $finalMenuResponse['option_groups'] = [];
        $finalMenuResponse['flush_options'] = $flash == 1 ? true : false; # master and local level request
        $finalMenuResponse['options'] = [];
        foreach ($getItems as $Key => $item) {

            $subcategoryId = "S-" . $item->sid;
            if (in_array($subcategoryId, $activeCategory) && $item->status == "1") {
                $platformPrice = [];
                foreach ($_ENV['PLATFORM'] as $platform) {
                    if ($platform == "justeat") {
                        $price['platform'] = $platform;
                        if ($item->justeat_price != "0.00") {
                            $price['price'] = floatval($item->justeat_price);
                        } else {
                            $price['price'] = floatval($item->price);
                        }
                        $platformPrice[] = $price;
                    }
                    if ($platform == "deliveroo") {
                        $price['platform'] = $platform;
                        if ($item->deliveroo_price != "0.00") {
                            $price['price'] = floatval($item->deliveroo_price);
                        } else {
                            $price['price'] = floatval($item->price);
                        }
                        $platformPrice[] = $price;
                    }
                    if ($platform == "ubereats") {
                        $price['platform'] = $platform;
                        if ($item->uber_eat_price != "0.00") {
                            $price['price'] = floatval($item->uber_eat_price);
                        } else {
                            $price['price'] = floatval($item->price);
                        }
                        $platformPrice[] = $price;
                    }
                }


                $finalMenuResponse['items'][$Key] = [
                    'ref_id' => "$item->id",
                    'title' => str_replace(["<br>", "Â"], "", $item->name),
                    'available' => $item->status == "1" ? true : false,
                    'ref_title' => "[S-$item->sid]", # new filed
                    'description' => str_replace(["<br>", "Â"], "", $item->description),
                    'sold_at_store' => true, # new filed
                    'markup_price' => floatval(0), # new filed
                    'serves' => 1, # new filed
                    'sort_order' => $item->order,
                    'price' => floatval($item->price),
                    'external_price' => floatval(0), # new filed
                    'weight' => 0, # new filed
                    'current_stock' => -1, # new filed
                    'recommended' => true, # new filed
                    'food_type' => "4", # new filed
                    'category_ref_ids' => ["$subcategoryId"],
                    'translations' => [], # new filed
                    'fulfillment_modes' => $item->options == 1 ? ["pickup"] : ($item->options == 0 ? ["delivery"] : ["pickup", "delivery"]),
                    'img_url' => $item->image ? $_ENV['FUSION_BUCKET'] . 'menu/' . $item->image : "",
                    'included_platforms' => $_ENV['PLATFORM'],
                    'clear_option_group' => true
                ];

                if (count($platformPrice) > 0) {
                    $finalMenuResponse['items'][$Key]['platform_pricing'] = $platformPrice;
                }

                $createAddonDetail = $this->createAddonDetail($item, $item->addon, $clientId, $finalMenuResponse, $item->sid);
                $finalMenuResponse['option_groups'] = $createAddonDetail['option_groups'];
                $finalMenuResponse['options'] = $createAddonDetail['options'];
            }
            // return $createAddonDetail;

        }
        return $finalMenuResponse;
    }

    public function createAddonDetail($item, $addonId, $clientId, $finalMenuResponse, $subcategoryId) 
    {
        while ($addonId != 0) {
            $client = new Client($clientId);
            $getAddonDetail = $client->query("CALL getAddonDetailWithoutStatus($addonId)");
            $getAddonItem = $client->queryAll("CALL getAllAddonItemWithoutStatus()");
            $client->connectionClose();
            $found = false;
    
            foreach ($finalMenuResponse['option_groups'] as $addonKey => $optionGroup) {
                if ($getAddonDetail->id == $optionGroup['ref_id']) {
                    $found = true;
                    array_push($finalMenuResponse['option_groups'][$addonKey]['item_ref_ids'], "$item->id");
                    break; // Exit loop if match found
                }
            }
    
            if (!$found) {
                $addonDetail = [
                    'ref_id' => "$getAddonDetail->id",
                    'title' => str_replace(["<br>", "Â"], "", $getAddonDetail->description),
                    'ref_title' => str_replace(["<br>", "Â"], "", $getAddonDetail->name),
                    'min_selectable' => ($getAddonDetail->limit == '0') ? 0 : $getAddonDetail->limit,
                    'max_selectable' => ($getAddonDetail->limit == '0') ? -1 : $getAddonDetail->limit,
                    'display_inline' => true, # new field
                    'active' => $getAddonDetail->status == "1" ? true : false,
                    'clear_item_ref_ids' => false, # master level request
                    'item_ref_ids' => ["$item->id"],
                    'translations' => [] # new field
                ];
                array_push($finalMenuResponse['option_groups'], $addonDetail);
                $createAddonItem = $this->createAddonItem($getAddonItem, $getAddonDetail->id, $finalMenuResponse, $subcategoryId, $item->id);
                $finalMenuResponse['options'] = $createAddonItem['options'];
                // return $createAddonItem;
            }
            $addonId = $getAddonDetail->next ? $getAddonDetail->next : 0; // Update addonId for the next iteration
        }
    
        return $finalMenuResponse;
    }
    
    public function createAddonItem($getAddonItem, $addonItemId, $finalMenuResponse, $subcategoryId, $itemId) 
    {
        while ($addonItemId != 0) {
            $addonData = array_filter($getAddonItem, function ($addon) use ($addonItemId) {
                return $addon->aid == $addonItemId;
            });
            foreach($addonData as $addons) {
                $found = false;
                if($addonItemId != 0) {
                    foreach ($finalMenuResponse['options'] as $addonKey => $options) {
                        if ($addons->id == $options['ref_id']) {
                            $found = true;
                            array_push($finalMenuResponse['options'][$addonKey]['opt_grp_ref_ids'], "$addonItemId");
                            break; // Exit loop if match found
                        }
                    }

                    if (!$found) {
                        $addonItem = [
                            'ref_id' => "$addons->id",
                            'title' => str_replace(["<br>", "Â"], "", $addons->name),
                            'description' => "", # new field
                            'ref_title' => "[S-$subcategoryId], [I-$itemId], [AG-$addonItemId]", # new field
                            'weight' => 0, # new field   
                            'food_type' => "4", # new field
                            'available' => $addons->status == "1" ? true : false,
                            'price' => floatval($addons->price),
                            'sold_at_store' => true, # new field
                            'opt_grp_ref_ids' => ["$addonItemId"],
                            'clear_opt_grp_ref_ids' => false, # master level request
                            'nested_opt_grps' => [], # new field
                            'translations' => [], # new field
                        ];
                        array_push($finalMenuResponse['options'], $addonItem); // Add the new addon
                    }   
                }
            }
            $addonItemId = $addons->next ? $addons->next : 0; // Update addonId for the next iteration      
        }
        return $finalMenuResponse;
    }    
}