<?php
namespace App\Models;

class OrderList extends DB
{
    public function getNewOrderCount($domain)
    {
        $preorderSort = 0;
        // $getVisibleOrder = $this->getVisibleOrder($domain, $preorderSort);
        $count = 0;
        // foreach ($getVisibleOrder as $key => $order) {
        //     if($order['status'] == 0) {
        //         $count += 1;
        //     }
        // }
        $getVisibleUrbanOrder = $this->getVisibleUrbanPiperOrder($domain);
        foreach ($getVisibleUrbanOrder as $key => $order) {
            if($order['order_status'] == "Placed") {
                $count += 1;
            }
        }
        return $count;
    }
    
    public function getOrderData($domain)
    {
        # printer setting config
        $getPrinter = $this->getPrinter($domain);
        # visible orders list
        $getVisibleOrder = $this->getVisibleOrder($domain, $getPrinter['preorder_sort']);
        $orderResult = [];
        foreach($getVisibleOrder as $key => $data) {
            $orderResult[$key] = $data;
            $orderResult[$key]['user'] = $this->getOrderUser($domain, $data['id']);
            if($data['otype'] == 0 && ($data['status'] == 1 || $data['status'] == 3)) {
                $orderResult[$key]['driver'] = $this->getOrderDriver($domain, $data['id']);
            }
        }
        # active driver status
        $getDriver = $this->getDriver($domain);
        $driver = (count($getDriver) && $getDriver[0]['status']) ? true : false;
        # cooking time config
        $getCookingTime = $this->getCookingTime($domain);
        # auto done config
        $getAutoDoneConfig = $this->getAutoDoneConfig($domain);
        
    	$orderList = [];
        foreach ($orderResult as $key => $order) {
            $currentOrder = $this->getFusionOrderConfig($domain, $order, $driver, $getCookingTime, $getAutoDoneConfig, $getPrinter);
            $orderList[] = $currentOrder;
        }
        return $orderList;
    }  

    public function getFusionOrderWithId($domain, $orderId)
    {
        # printer setting config
        $getPrinter = $this->getPrinter($domain);
        # active driver status
        $getDriver = $this->getDriver($domain);
        $driver = (count($getDriver) && $getDriver[0]['status']) ? true : false;
        # cooking time config
        $getCookingTime = $this->getCookingTime($domain);
        # auto done config
        $getAutoDoneConfig = $this->getAutoDoneConfig($domain);
        # get store detail
        $contact = $this->getContacts($domain);
        
        # order detail
        $order = $this->getOrderDetail($domain, $orderId);
        // return $order;
        $order['user'] = $this->getOrderUser($domain, $orderId);
        if($order['otype'] == 0 && ($order['status'] == 1 || $order['status'] == 3)) {
            $order['driver'] = $this->getOrderDriver($domain, $orderId);
        }
        $currentOrder = $this->getFusionOrderConfig($domain, $order, $driver, $getCookingTime, $getAutoDoneConfig, $getPrinter);

        $currentOrder['instruction'] = $order['inst'];

        # promo discount
        if($order['promo_discount'] != "0.00" && $order['promo_discount'] != "" && $order['promo_discount'] != null) {
            $currentOrder['promo'] = number_format($order['promo_discount'] ,2);
        }
        # voucher discount
        if($order['voucher_discount'] != "0.00" && $order['voucher_discount'] != "" && $order['voucher_discount'] != null) {
            $currentOrder['voucherDiscount'] = number_format($order['voucher_discount'] ,2);
        }
        # discount
        if($order['con'] != "0.00" && $order['con'] != "" && $order['con'] != null) {
            $currentOrder['discount'] = number_format($order['con'] ,2);
        }
        # gift discount
        if($order['gift'] != "0.00" && $order['gift'] != "" && $order['gift'] != null) {
            $currentOrder['gift'] = $order['gift'];
            $currentOrder['giftQty'] = number_format($order['gqty'] ,2);
        }
        #round amount
        if($order['roundamount'] != "0.00" && $order['roundamount'] != "" && $order['roundamount'] != null) {
            $currentOrder['roundAmount'] = number_format($order['roundamount'] ,2);
        }
        #extra donate
        if($order['extraDonate'] != "0.00" && $order['extraDonate'] != "" && $order['extraDonate'] != null) {
            $currentOrder['extraDonate'] = number_format($order['extraDonate'] ,2);
        }
        # delivery charge
        if($order['delivery_charge'] != "0.00" && $order['delivery_charge'] != "" && $order['delivery_charge'] != null) {
            $currentOrder['deliveryCharge'] = number_format($order['delivery_charge'] ,2);
        }
        # driver tip for delivery order and donation for collection order 
        if($order['ride_amt'] != "0.00" && $order['ride_amt'] != "" && $order['ride_amt'] != null) {
            if($order['otype'] == 0) {
                $currentOrder['driverTip'] = number_format($order['ride_amt'] ,2);
            } else {
                $currentOrder['donation'] = number_format($order['ride_amt'] ,2);
            }
        }
        # service charge
        if(($order['bank'] != "0.00" || $order['fbank'] != "0.00" || $order['service_charge'] != "0.00") &&
        ($order['bank'] != "" || $order['fbank'] != "" || $order['service_charge'] != "") &&
        ($order['bank'] !=null || $order['fbank'] !=null || $order['service_charge'] !=null)) {
            $total_service_charge  = $order['bank'] + $order['fbank'] + $order['service_charge'];
            $currentOrder['serviceCharge'] = number_format($total_service_charge  ,2);
        }
        # baggage amount
        if($order['bagage'] != "0.00" && $order['bagage'] != "" && $order['bagage'] != null) {
            $currentOrder['baggage'] = number_format($order['bagage'] ,2);
        }
        # total amount
        $currentOrder['orderSubtotalAmount'] = number_format(($order['sub_total']) ,2);
       
        # expected time calculation
        $getCookingTime['delivery'] = $getCookingTime['delivery'] ?? "0";
        $getCookingTime['collection'] = $getCookingTime['collection'] ?? "0";
        $tatTime = $order['late'];
        $tatTime += ($order['otype'] == 0) ? $getCookingTime['delivery'] : $getCookingTime['collection'];
        $currentOrder['estimated'] =  $order['preorder'] ? $order['preorder'] : $order['datetime']+($tatTime*60);
        $currentOrder['storeName'] =  $contact['name'];

        # customer loyalty point
        if($order['user_id'] != 0) {
            if($order['online'] == 2) {
                $fusionKitchen = new FusionKitchen();
                $getLoyaltyPoints = $fusionKitchen->getLoyaltyPointWithOrderTime($order['user_id'], $order['datetime']);
            } else {
                $getLoyaltyPoints = $this->getLoyaltyPoints($domain, $order['user_id'], $order['datetime']);  
            }
            $currentOrder['loyaltyPoint'] = $getLoyaltyPoints['credit'] - $getLoyaltyPoints['debit'];
        } else {
            $currentOrder['loyaltyPoint'] = 0;
        }
        $currentOrder['message'] =  $getPrinter['message'];
        $currentOrder['staff'] =  $order['staff'];
        $currentOrder['refund'] =  $order['refund'] && $order['ptype'] != 0 ? true : false;
        
        # user detail
        $currentOrder['user'] = $order['user'];

        # get ordered item details
        $getOrderItem = $this->getOrderedItem($domain, $orderId);

        # menu sort functions with ascending order
        $sortingOrder = array(
            "main" => $getPrinter['main'],
            "starter" => $getPrinter['starter'],
            "dessert" => $getPrinter['dessert'],
            "appetiser" => $getPrinter['appetiser'],
            "sides" => $getPrinter['sides'],
        );
        asort($sortingOrder);
        $sortingOrder['unknown'] = "0";

        // Initialize arrays for each item type
        $itemTypeArrays = [];
        foreach ($sortingOrder as $key => $value) {
            $itemTypeArrays[$value] = [];
        }

        // Arrange items based on item type
        foreach ($getOrderItem as $key => $item) {
            $getItemWithId = $this->getItemWithId($domain, $item->itemid);
            $orderTypeKey = $item->item_type;
            $itemType = isset($sortingOrder[$orderTypeKey]) ? $sortingOrder[$orderTypeKey] : '0';
            
            // Add the item to the corresponding item type array
            $currentOrderItem = [
                'itemId' => $item->itemid,
                'itemName' => $item->item_name,
                'count' => $item->qty,
                'price' => $item->price,
                'totalWithOutAddon' => $item->total,
                'totalWithAddon' => $item->total,
                'instruction' => $item->instruction,
                'itemType' => $orderTypeKey,
                'printer' => $getItemWithId['printer'],
                'addon' => []
            ];
            
            // Get ordered addon details
            $orderAddons = $this->getOrderAddon($domain, $item->id);
            
            foreach ($orderAddons as $addon) {
                $currentOrderItem['addon'][] = [
                    'addonId' => $addon->addonid,
                    'addonName' => $addon->addon_name,
                    'qty' => $addon->qty,
                    'price' => $addon->price
                ];
                $currentOrderItem['totalWithAddon'] += $addon->price;
            }
            
            $itemTypeArrays[$itemType][] = $currentOrderItem;
        }
        
        // Merge arrays based on order type mapping
        $orderedItems = [];
        foreach ($sortingOrder as $key => $value) {
            if (isset($itemTypeArrays[$value])) {
                $orderedItems = array_merge($orderedItems, $itemTypeArrays[$value]);
            }
        }
        $currentOrder['item'] = $orderedItems;

        // adding gift to item list for bill
        if($order['gift'] != "" && $order['gift'] != 0) {
            $giftData = array(
                "itemId" => 0,
                "itemName" => $order['gift'],
                "count" => $order['gqty'],
                "price" => "0.00",
                "totalWithOutAddon" => "0.00",
                "totalWithAddon" => "0.00",
            );
            array_push($currentOrder['item'], $giftData);
        }

        return $currentOrder;
    }

    public function getFusionOrderConfig($domain, $order, $driver, $getCookingTime, $getAutoDoneConfig, $getPrinter)
    {
        $orderStatus = array('New Order', 'Order in Progress', 'Rejected', 'Delivered', 'Cancelled');
        $platformStatus = array(
            '0' => 'Website', 
            '1' => 'EPOS', 
            '2' => 'FK',
            '3' => 'QR',
            '4' => 'FMB',
        );
        $paymentType = array(
            '0' => 'Cash', 
            '1' => 'Card', 
            '2' => 'Card at shop', 
            '3' => 'Qr', 
            '4' => 'Unpaid', 
            '5' => 'Motto payment',
            '6' => 'Pay link', 
            '7' => 'Google pay', 
            '8' => 'Apple pay', 
            '9' => 'wallet', 
            '10' => 'Klarna', 
            '11' => 'PDQ',
            '14' => 'Paypal',
        );

        $info = "";
        // $info .= $order['online'] ? "" : "Online ";

        if ($order['otype'] == 0) {
            $info .= "Delivery";
        } elseif ($order['otype'] == 1) {
            $info .= "Collection";
        } elseif ($order['otype'] == 2) {
            // $tbl = $this->getOrderTable($domain, $order['id']);
            // if ($tbl) {
            //     if ($order['status'] == 1) {
            //         continue;
            //     } else {
            //         $info .= $tbl['tablename'];
            //     }
            // } else {
                $info .= "Inside";
            // }
        // } else {
            // $tbl = "";
        }
        
        $amount = number_format(($order['total'] + $order['fbank'] + $order['ride_amt'] + $order['service_charge']),2);
        $currentOrder = [
            'id' => $order['id'],
            'preorder' => ($order['preorder'] == 0) ? false : true,
            'no' => !$getPrinter['number'] ? $order['id'] : $order['sno'],
            'customer' => $order['user'] ? $order['user']['fname']." ".$order['user']['lname'] : "",
            'address' => ($order['otype'] == 0) ? $order['user'] ? $order['user']['dno'].", ".$order['user']['add1'].", ".$order['user']['add2'].", ".$order['user']['postcode'] : "" : $info,
            'postcode' => $order['user'] ? $order['user']['postcode'] : "",
            'amount' => $amount,
            'ptype' => $order['ptype'],
            'paymentType' => $paymentType[$order['ptype']],
        ];

        $currentOrder['otype'] = $order['otype'];
        $currentOrder['status'] = $order['status'];
        if ($order['status'] == '1') {
            if ($getCookingDetail = $this->getCookingDetail($domain, $order['id'])) {
                $currentOrder['orderStatus'] = $getCookingDetail['status'] ? "Ready" : "Cooking";
            } else {
                $currentOrder['orderStatus'] = $orderStatus[$order['status']];
            }
        } else {
            $currentOrder['orderStatus'] = $orderStatus[$order['status']];
        }

        if($order['status'] == 0 || $order['status'] == 1) {
            $target = $order['otype'] == 0 ? $getCookingTime['delivery'] : $getCookingTime['collection'];
            $time = $order['preorder'] ? -round((time()-$order['preorder'])/60) : $target - round((time()-$order['datetime'])/60);

            if($time + $order['late'] > 0) {
                $currentOrder['tat'] = $time + $order['late'];
            } else {
                $currentOrder['tat'] = 0;
        
                // start hide auto done
                if($order['otype'] == 1 && $order['status'] == 1) {
                    if($getAutoDoneConfig["auto_done"] == 1) {
                        $this->updateOrderStatus($domain ,$order['id'], 3);
                    }
                }
                if($order['otype'] == 2 && $order['status'] == 1) {
                    $datetime=$order['datetime'];
                    $doneTime=strtotime('+12 hour',$datetime);
                    $t=time();
                    if($doneTime <= $t) {
                        if($getAutoDoneConfig["auto_done"] == 1) {
                            $this->updateOrderStatus($domain ,$order['id'], 3);
                        }  
                    }
                }
                if($order['otype'] == 0 && $order['status'] == 1) {
                    if($driver && isset($order['driver'])) {
                        if($getAutoDoneConfig["auto_done"] == 1) {
                            $this->updateOrderStatus($domain ,$order['id'], 3);
                        }
                    } else {
                        if($getAutoDoneConfig["auto_done"] == 1) {
                            $this->updateOrderStatus($domain ,$order['id'], 3);
                        }
                    }
                }
            }
        } else {
            $currentOrder['tat'] = 0;
        }
            
        // $currentOrder['table'] = isset($tbl) ? $tbl : "";
        # driver details
        $currentOrder['driverName'] = "";	
        if(($order['status'] == 1 || $order['status'] == 3) && $driver && $order['otype'] == 0){
            if(isset($order['driver']) && $order['driver'] != false){
                $currentOrder['driverName'] = $order['driver']['name'];
                $currentOrder['driverStatus'] = "Send to ".$order['driver']['name'];
            }else
                $currentOrder['driverName'] = "";
        }
        $currentOrder['driverConfig'] = $driver;
        $currentOrder['online'] = $order['online'];
        $currentOrder['platform'] = $platformStatus[$order['online']];
        $currentOrder['platformType'] = 1;
        $currentOrder['placedTime'] = intval($order['datetime']);

        return $currentOrder;
    }

    public function getUrbanPiperOrderData($domain)
    {
        $getVisibleUrbanOrder = $this->getVisibleUrbanPiperOrder($domain);
        $orderList = [];
        $platformStatus = array(
            'justeat' => 10, 
            'deliveroo' => 11,
            'ubereats' => 12,  
        );
        $paymentType = array(
            'cash' => 0, 
            'card_on_delivery' => 2,
            'wallet_credit' => 9, 
            'prepaid' => 16, 
            'payment_gateway' => 17, 
            'paytm' => 18, 
            'simpl' => 19, 
            'aggregator' => 20, 
        );
        $orderType = array(
            'delivery' => 0, 
            'pickup' => 1,
        );
        $orderStatus = array(
            'Placed' => 10, 
            'Acknowledged' => 11,  
            'Food Ready' => 12, 
            'Dispatched' => 13, 
            'Completed' => 14, 
            'Cancelled' => 15, 
        );
        foreach($getVisibleUrbanOrder as $key => $order) {
            $currentOrder = [];
            $customerData = json_decode($order['customer']);
            $orderData = json_decode($order['order_detail']);
            $storeData = json_decode($order['store']);
            $deliveryData = json_decode($order['delivery_detail']);
            $expected = ($order['order_type'] == "delivery")
                ? $orderData->delivery_datetime
                : ($orderData->expected_pickup_time ?? $orderData->delivery_datetime);

            # driver detail
            $driverName = "";
            $driverStatus = "";
            if($deliveryData != null) {
                $driverName = $deliveryData->delivery_info->delivery_person_details->name;
                $driverStatus = $deliveryData->delivery_info->current_state;
            }

            # tat time calculation
            $expectedTimeSec = $expected / 1000;
            $currentTimestampSec = time();
            if ($expectedTimeSec >= $currentTimestampSec) {
                $timeDifferenceSec = $expectedTimeSec - $currentTimestampSec;
                $timeDifferenceMinutes = floor($timeDifferenceSec / 60);
            } else {
                $timeDifferenceMinutes = 0;
            }

            # preorder status calculation
            $orderPlacedTimestampSec = $order['date_string'] / 1000;
            if ($expectedTimeSec >= $orderPlacedTimestampSec) {
                $placedTimeDifferenceSec = $expectedTimeSec - $orderPlacedTimestampSec;
                $placedTimeDifferenceMinutes = floor($placedTimeDifferenceSec / 60);
            } else {
                $placedTimeDifferenceMinutes = 0;
            }
        
            // $currentDate = date('Y-m-d', time());
            // $timestampDate = date('Y-m-d', $expectedTimeSec);

            // $preorder = "";
            // if ($timestampDate == $currentDate) {
            //     $preorder = "The provided timestamp corresponds to today's date.".$timestampDate;
            // } else {
            //     $preorder = "The provided timestamp does not correspond to today's date.".$timestampDate;
            // }

            $currentOrder['id'] = $order['order_id'];
            $currentOrder['status'] = $orderStatus[$order['order_status']];
            $currentOrder['preorder'] = $orderData->prep_time->max <= $placedTimeDifferenceMinutes ? true : false;
            $currentOrder['no'] = $order['order_id'];
            $currentOrder['customer'] = $customerData->name;
            $currentOrder['address'] = ($order['order_type'] == "delivery")
                ? "{$customerData->address->line_1}, {$customerData->address->line_2}, {$customerData->address->pin}"
                : "Collection";
            $currentOrder['postcode'] = $customerData->address->pin;
            $currentOrder['amount'] = number_format($order['total'], 2);
            $currentOrder['ptype'] = $paymentType[$order['payment_type']];
            $currentOrder['paymentType'] = $order['payment_type'];
            $currentOrder['otype'] = $orderType[$order['order_type']];
            $currentOrder['orderStatus'] = $order['order_status'];
            $currentOrder['tat'] = $timeDifferenceMinutes;
            $currentOrder['driverName'] = $driverName;
            $currentOrder['online'] = $platformStatus[$order['platform']];
            $currentOrder['platform'] = $order['platform'];
            $currentOrder['platformType'] = 2;
            $currentOrder['clientId'] = $storeData->merchant_ref_id;
            $currentOrder['placedTime'] = round($order['date_string'] / 1000);
            $orderList[] = $currentOrder;
        }
        return $orderList;
    }

    public function getUrbanOrderWithId($domain, $orderId)
    {
        $getUrbanPiperOrderWithId = $this->getUrbanPiperOrderWithId($domain, $orderId);
        $getUrbanPiperOrderWithId['customer'] = json_decode($getUrbanPiperOrderWithId['customer']);
        $getUrbanPiperOrderWithId['next_status'] = json_decode($getUrbanPiperOrderWithId['next_status']);
        $getUrbanPiperOrderWithId['items'] = json_decode($getUrbanPiperOrderWithId['items']);
        $getUrbanPiperOrderWithId['order_detail'] = json_decode($getUrbanPiperOrderWithId['order_detail']);
        $getUrbanPiperOrderWithId['payment'] = json_decode($getUrbanPiperOrderWithId['payment']);
        $getUrbanPiperOrderWithId['store'] = json_decode($getUrbanPiperOrderWithId['store']);
        $getUrbanPiperOrderWithId['delivery_detail'] = json_decode($getUrbanPiperOrderWithId['delivery_detail']);

        return $getUrbanPiperOrderWithId;
    }

    public function getVisibleOrder($domain, $sorting)
    {
        $client = new Client($domain);
        $getVisibleOrder = $client->queryAll("CALL getVisibleOrder($sorting)");
        $getVisibleOrder = json_decode(json_encode($getVisibleOrder), true);
        $client->connectionClose();
        return $getVisibleOrder;
    }
    
    public function getOrderUser($domain, $orderId)
    {
        $client = new Client($domain);
        $getOrderUser = $client->query("CALL getOrderUser($orderId)");
        $getOrderUser = json_decode(json_encode($getOrderUser), true);
        $client->connectionClose();
        return $getOrderUser;
    }

    public function getOrderDriver($domain, $orderId)
    {
        $client = new Client($domain);
        $getOrderDriver = $client->query("CALL getOrderDriver($orderId)");
        $getOrderDriver = json_decode(json_encode($getOrderDriver), true);
        $client->connectionClose();
        return $getOrderDriver;
    }

    public function getDriver($domain)
    {
        $client = new Client($domain);
        $getDriver = $client->queryAll("CALL getDriver()");
        $getDriver = json_decode(json_encode($getDriver), true);
        $client->connectionClose();
        return $getDriver;
    }

    public function getDriverWithId($domain, $driverId)
    {
        $client = new Client($domain);
        $getDriver = $client->query("CALL getDriverWithId($driverId)");
        $getDriver = json_decode(json_encode($getDriver), true);
        $client->connectionClose();
        return $getDriver;
    }

    public function getPrinter($domain)
    {
        $client = new Client($domain);
        $getPrinter = $client->query("CALL getPrinter()");
        $getPrinter = json_decode(json_encode($getPrinter), true);
        $client->connectionClose();
        return $getPrinter;
    }

    public function getOrderTable($domain, $orderId)
    {
        $client = new Client($domain);
        $getOrderTable = $client->query("CALL getOrderTable($orderId)");
        $getOrderTable = json_decode(json_encode($getOrderTable), true);
        $client->connectionClose();
        return $getOrderTable;
    }

    public function getCookingDetail($domain, $orderId)
    {
        $client = new Client($domain);
        $getOrderTable = $client->query("CALL getCookingDetail($orderId)");
        $getOrderTable = json_decode(json_encode($getOrderTable), true);
        $client->connectionClose();
        return $getOrderTable;
    }

    public function getCookingTime($domain)
    {
        $record = array();
        $client = new Client($domain);
        $cooking_time = $client->query("call getCollectionTime()");
        $client->connectionClose();

        if($cooking_time->collection || $cooking_time->delivery)
        {
            $record['delivery'] = $cooking_time->delivery;
            $record['collection'] = $cooking_time->collection;
        }
        else
        {
            $day = date('w');
            if($day == 0)
            {
                $col_cooking = "collection7";
                $del_cooking = "delivery7";
            } 
            else 
            {
                $col_cooking = "collection".$day;
                $del_cooking = "delivery".$day;
            }
            $record['collection'] = $cooking_time->$col_cooking;
            $record['delivery'] = $cooking_time->$del_cooking;
        }

        // $stuart = $this->getStuartStatus($clientId);
        // if($stuart->status == 1) {
        //     if($cooking_time->stuart_time)
        //         $record['stuart_time'] = $cooking_time->stuart_time;
        //     else
        //         $record['stuart_time'] = "20";

        //     $record['extraPrepTime'] = $cooking_time->extraPrepTime;
        // }

        return $record;
    }

    public function getAutoDoneConfig($domain)
    {
        $client = new Client($domain);
        $getAutoDoneConfig = $client->query("CALL getAutoDoneConfig()");
        $getAutoDoneConfig = json_decode(json_encode($getAutoDoneConfig), true);
        $client->connectionClose();
        return $getAutoDoneConfig;
    }

    public function updateOrderStatus($domain, $orderId, $status)
    {
        $client = new Client($domain);
        $client->query("CALL updateOrderStatus($orderId, $status)");
        $client->connectionClose();
        return true;
    }

    public function updateLateOrder($domain, $orderId, $late)
    {
        $client = new Client($domain);
        $client->query("CALL updateLateOrder($orderId, $late)");
        $client->connectionClose();
        return true;
    }

    public function updateCancelOrderStatus($domain, $orderId, $status, $reason, $comment)
    {
        $client = new Client($domain);
        $currentTimes = time();
        $client->query("CALL updateCancelOrderStatus($orderId, $status, '".addslashes($reason)."', '".addslashes($comment)."', '".addslashes($currentTimes)."')");
        $client->connectionClose();
        return true;
    }

    public function getOrderDetail($domain, $orderId)
    {
        $client = new Client($domain);
        $getOrderDetail = $client->query("CALL getOrderDetail($orderId)");
        $getOrderDetail = json_decode(json_encode($getOrderDetail), true);
        $client->connectionClose();
        return $getOrderDetail;
    }

    public function getOrderedItem($domain, $orderId)
    {
        $client = new Client($domain);
        $getOrderedItem = $client->queryAll("CALL getOrderedItem($orderId)");
        $client->connectionClose();
        return $getOrderedItem;
    }

    public function getOrderAddon($domain, $addonId)
    {
        $client = new Client($domain);
        $getOrderAddon = $client->queryAll("CALL getOrderAddon($addonId)");
        $client->connectionClose();
        return $getOrderAddon;
    }

    public function getVisibleUrbanPiperOrder($domain)
    {
        $client = new Client($domain);
        $getVisibleUrbanPiperOrder = $client->queryAll("CALL getVisibleUrbanPiperOrder()");
        $getVisibleUrbanPiperOrder = json_decode(json_encode($getVisibleUrbanPiperOrder), true);
        $client->connectionClose();
        return $getVisibleUrbanPiperOrder;
    }

    public function getUrbanPiperOrderWithId($domain, $orderId)
    {
        $client = new Client($domain);
        $getUrbanPiperOrder = $client->query("CALL getUrbanPiperOrder($orderId)");
        $getUrbanPiperOrder = json_decode(json_encode($getUrbanPiperOrder), true);
        $client->connectionClose();
        return $getUrbanPiperOrder;
    }

    public function getContacts($domain)
    {
        $client = new Client($domain);
        $contact = $client->query("CALL getContacts()");
        $contact = json_decode(json_encode($contact), true);
        $client->connectionClose();
        return $contact;
    }

    public function getLoyaltyPoints($domain, $customerId, $orderDate)
    {
        $client = new Client($domain);
        $getLoyaltyPoints = $client->query("CALL getLoyaltyPoints($customerId, $orderDate)");
        $getLoyaltyPoints = json_decode(json_encode($getLoyaltyPoints), true);
        $client->connectionClose();
        return $getLoyaltyPoints;
    }

    public function updateHideFusionOrderStatus($domain, $orderId)
    {
        $client = new Client($domain);
        $client->query("CALL updateHideFusionOrder($orderId)");
        $client->connectionClose();
        return true;
    }

    public function updateHideUrbanOrderStatus($clientId, $orderId)
    {
        $client = new Client($clientId);
        $client->query("CALL updateHideUrbanOrder($orderId)");
        $client->connectionClose();
        return true;
    }

    public function updateOrderDriver($domain, $driver, $orderId)
    {
        $currentTimes = time();
        $client = new Client($domain);
        $client->query("CALL updateOrderDriver($driver[id], '".addslashes($driver['empid'])."' , '".addslashes($driver['name'])."' , $orderId, $currentTimes)");
        $client->connectionClose();
        return true;
    }

    public function createOrderDriver($domain, $driver, $orderId)
    {
        $currentTimes = time();
        $client = new Client($domain);
        $client->query("CALL createOrderDriver($driver[id], '".addslashes($driver['empid'])."' , '".addslashes($driver['name'])."' , $orderId, $currentTimes, @insert_id)");
        $client->connectionClose();
        return true;
    }

    public function getItemWithId($domain, $itemId)
    {
        $client = new Client($domain);
        $getItemWithId = $client->query("CALL getItemWithId($itemId)");
        $getItemWithId = json_decode(json_encode($getItemWithId), true);
        $client->connectionClose();
        return $getItemWithId;
    }
    
}